︠7e5506a6-1748-4bc1-b9fe-c0a86b0fc2b3︠
import numpy as np
︡385a29b9-9765-48c7-9ca9-80dc7e0afb37︡︡
︠81e1c77e-568c-4a2a-9d98-7e4d1b305be4︠
def posmax(A):
    pos=A.argmax()
    N=A.shape[0] #je suppose que A est carree
    lin=index/N
    col=mod(index,N)
    return(lin,col)
︡45787e57-8bbd-47bb-be75-655a27e9fa41︡︡
︠ff56437d-b93a-4180-9491-1c01ee1a05cf︠
def system_lineaire(A,b):
    N=A.shape[0] # matrice carree*
    #on met des zero sur chaque colonne
    for j in range(0,N-1):
        c=abs(A[j:N,j])
        #permutation indices p et j
        #abs est la val absolue
        p=j+c.argmax()
        #ne pas oublier ici le .copy()
        v=A[j,:].copy()
        A[j,:]=A[p,:]
        A[p,:]=v.copy()
        # fin de la permutation
        # permutation de b à ne pas oublier
        t=b[j]
        b[j]=b[p]
        b[p]=t
        pivot=A[j,j]
        for i in range(j+1,N):
            b[i]=b[i]-(A[i,j]/pivot)*b[j]
            A[i,:]=A[i,:]-(A[i,j]/pivot)*A[j,:]
    #resolution du système triangulaire
    for j in range(N-1,0,-1):
        pivot=A[j,j]
        for i in range(j-1,-1,-1):
            b[i]=b[i]-(A[i,j]/pivot)*b[j]
            A[i,:]=A[i,:]-(A[i,j]/pivot)*A[j,:]
    sol=b/A.diagonal()
    return(sol)
︡27764730-51da-4f41-a876-0a44e34766ed︡︡
︠a58caf4e-3036-4713-8d8a-f3b3a7a02a25︠
A=np.array ([[11.,2.,3.,4.],[5.,6.,7.,108.],[10.,11.,12.,13.],[34.,45.,46.,57.]])
Asauve=A.copy()
b=np.array([2.,3.,4.,5.])
︡d9f6c709-c38c-4416-be81-ba8c91d6d952︡︡
︠9f59ca40-b2fb-47e6-b2e0-931725fd8810︠
sol=system_lineaire(A,b)
print(sol)
︡74770d17-a162-4fab-b619-299c3a9b9001︡{"stdout": "[-0.23176471 -3.97176471  4.18       -0.01176471]"}︡
︠4a66f860-4ab5-4efc-8352-ff36669249ca︠
np.dot(Asauve,sol)
︡d0a52c5c-c1ce-479d-95cb-8c26aca9881a︡{"stdout": "array([ 2.,  3.,  4.,  5.])"}︡
︠5bc6f20b-43ee-411b-880c-ba43ff1b76c1︠
c=np.array ([[1,2,3],[-35,23,6],[-15,13,16]])
︡e6232b75-555e-419a-b330-e0b9179a6078︡︡
︠bb0ec217-6e63-4520-8b81-362e37d6f1b7︠
b=abs(c)
︡2262aca4-7edf-4de1-a39a-b5c938dcc02b︡︡
︠db054618-4b5a-4f97-aad0-0ba007fb8c33︠
b
︡4c6f4059-4574-4aec-812d-a21385128b35︡{"stdout": "array([[ 1,  2,  3],\n       [35, 23,  6],\n       [15, 13, 16]])"}︡
︠41db4e3d-a49a-45cc-863f-6043944826ac︠
b.argmax(1)
︡07fba32f-0d3f-488b-9ceb-82a38512ae59︡{"stdout": "array([2, 0, 2])"}︡
︠48a2dd8b-34a5-4502-b2e0-4d3a09601606︠
np.argmax?
︡86ee063f-2948-4560-84cf-1f3ad77f7b66︡{"html": "<!--notruncate-->\n\n<div class=\"docstring\">\n    \n  <p><strong>File:</strong> /sagenb/sage_install/sage-4.7/local/lib/python2.6/site-packages/numpy/core/fromnumeric.py</p>\n<p><strong>Type:</strong> &lt;type &#8216;function&#8217;&gt;</p>\n<p><strong>Definition:</strong> np.argmax(a, axis=None)</p>\n<p><strong>Docstring:</strong></p>\n<blockquote>\n<p>Indices of the maximum values along an axis.</p>\n<dl class=\"docutils\">\n<dt>a <span class=\"classifier-delimiter\">:</span> <span class=\"classifier\">array_like</span></dt>\n<dd>Input array.</dd>\n<dt>axis <span class=\"classifier-delimiter\">:</span> <span class=\"classifier\">int, optional</span></dt>\n<dd>By default, the index is into the flattened array, otherwise\nalong the specified axis.</dd>\n</dl>\n<dl class=\"docutils\">\n<dt>index_array <span class=\"classifier-delimiter\">:</span> <span class=\"classifier\">ndarray of ints</span></dt>\n<dd>Array of indices into the array. It has the same shape as <span class=\"math\">a.shape</span>\nwith the dimension along <span class=\"math\">axis</span> removed.</dd>\n</dl>\n<p>ndarray.argmax, argmin\namax : The maximum value along a given axis.\nunravel_index : Convert a flat index into an index tuple.</p>\n<p>In case of multiple occurrences of the maximum values, the indices\ncorresponding to the first occurrence are returned.</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">&gt;&gt;&gt; </span><span class=\"n\">a</span> <span class=\"o\">=</span> <span class=\"n\">np</span><span class=\"o\">.</span><span class=\"n\">arange</span><span class=\"p\">(</span><span class=\"mi\">6</span><span class=\"p\">)</span><span class=\"o\">.</span><span class=\"n\">reshape</span><span class=\"p\">(</span><span class=\"mi\">2</span><span class=\"p\">,</span><span class=\"mi\">3</span><span class=\"p\">)</span>\n<span class=\"gp\">&gt;&gt;&gt; </span><span class=\"n\">a</span>\n<span class=\"go\">array([[0, 1, 2],</span>\n<span class=\"go\">       [3, 4, 5]])</span>\n<span class=\"gp\">&gt;&gt;&gt; </span><span class=\"n\">np</span><span class=\"o\">.</span><span class=\"n\">argmax</span><span class=\"p\">(</span><span class=\"n\">a</span><span class=\"p\">)</span>\n<span class=\"go\">5</span>\n<span class=\"gp\">&gt;&gt;&gt; </span><span class=\"n\">np</span><span class=\"o\">.</span><span class=\"n\">argmax</span><span class=\"p\">(</span><span class=\"n\">a</span><span class=\"p\">,</span> <span class=\"n\">axis</span><span class=\"o\">=</span><span class=\"mi\">0</span><span class=\"p\">)</span>\n<span class=\"go\">array([1, 1, 1])</span>\n<span class=\"gp\">&gt;&gt;&gt; </span><span class=\"n\">np</span><span class=\"o\">.</span><span class=\"n\">argmax</span><span class=\"p\">(</span><span class=\"n\">a</span><span class=\"p\">,</span> <span class=\"n\">axis</span><span class=\"o\">=</span><span class=\"mi\">1</span><span class=\"p\">)</span>\n<span class=\"go\">array([2, 2])</span>\n</pre></div>\n</div>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">&gt;&gt;&gt; </span><span class=\"n\">b</span> <span class=\"o\">=</span> <span class=\"n\">np</span><span class=\"o\">.</span><span class=\"n\">arange</span><span class=\"p\">(</span><span class=\"mi\">6</span><span class=\"p\">)</span>\n<span class=\"gp\">&gt;&gt;&gt; </span><span class=\"n\">b</span><span class=\"p\">[</span><span class=\"mi\">1</span><span class=\"p\">]</span> <span class=\"o\">=</span> <span class=\"mi\">5</span>\n<span class=\"gp\">&gt;&gt;&gt; </span><span class=\"n\">b</span>\n<span class=\"go\">array([0, 5, 2, 3, 4, 5])</span>\n<span class=\"gp\">&gt;&gt;&gt; </span><span class=\"n\">np</span><span class=\"o\">.</span><span class=\"n\">argmax</span><span class=\"p\">(</span><span class=\"n\">b</span><span class=\"p\">)</span> <span class=\"c\"># Only the first occurrence is returned.</span>\n<span class=\"go\">1</span>\n</pre></div>\n</div>\n</blockquote>\n\n\n</div>\n"}︡
